------------------------------------------------------------------------------------------
-- UIshowEquip file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- create the equipment window
------------------------------------------------------------------------------------------
function CreateUIShowReput(NamePlayerToShow)	
	local windowWidth = 420;
	local windowHeight = 0;

	UIShowReput=Turbine.UI.Lotro.GoldWindow(); 
	if(settings["nameAccount"]["account1"]["name"] ~= "")then
		windowHeight = (settings["nameAccount"]["account1"]["nbrAlt"] * 20) + 340;
	else
		windowHeight = 440;
	end
	UIShowReput:SetSize(windowWidth, windowHeight); 
	UIShowReput:SetText( "Reputation for " ..  NamePlayerToShow); 
	UIShowReput:SetPosition((Turbine.UI.Display:GetWidth()-UIShowReput:GetWidth())/2,(Turbine.UI.Display:GetHeight()-UIShowReput:GetHeight())/2); 

	UIShowReput.Message=Turbine.UI.Label(); 
	UIShowReput.Message:SetParent(UIShowReput); 
	UIShowReput.Message:SetSize(150,10); 
	UIShowReput.Message:SetPosition(UIShowReput:GetWidth()/2 - 75, UIShowReput:GetHeight() - 20); 
	UIShowReput.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	UIShowReput.Message:SetText(Strings.PluginText); 
	UIShowReput:SetZOrder(10);
	UIShowReput:SetWantsKeyEvents(true);
	UIShowReput:SetVisible(false);


	------------------------------------------------------------------------------------------
	--- button help
	------------------------------------------------------------------------------------------
	buttonDefineHelp = Turbine.UI.Extensions.SimpleWindow();
	buttonDefineHelp:SetParent( UIShowReput );
	buttonDefineHelp:SetPosition(windowWidth - 45, 35);
	buttonDefineHelp:SetSize( 20, 20 );
	buttonDefineHelp:SetVisible(true);
	buttonDefineHelp:SetMouseVisible(true);

	centerLabelHelp = Turbine.UI.Label();
	centerLabelHelp:SetParent(buttonDefineHelp);
	centerLabelHelp:SetPosition( 0, 0 );
	centerLabelHelp:SetSize( 20, 20  );
	centerLabelHelp:SetBackground(ResourcePath .. "Help.tga");
	centerLabelHelp:SetZOrder(-1);
	centerLabelHelp:SetMouseVisible(false);

	helpButtonLabel = Turbine.UI.Extensions.SimpleWindow();
	helpButtonLabel:SetParent( UIShowReput );
	helpButtonLabel:SetPosition (windowWidth - 20, 35);
	helpButtonLabel:SetSize( 180, 30 );
	helpButtonLabel:SetZOrder(10000);
	helpButtonLabel:SetVisible(false);
	helpButtonLabel:SetBackground(ResourcePath .. "/Cadre_180_30.tga");

	centerLabelBLabelHelp = Turbine.UI.Label();
	centerLabelBLabelHelp:SetParent(helpButtonLabel);
	centerLabelBLabelHelp:SetPosition( 2, 2 );
	centerLabelBLabelHelp:SetSize( 176, 26  );
	centerLabelBLabelHelp:SetText( Strings.PluginLabelHelp );
	centerLabelBLabelHelp:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	centerLabelBLabelHelp:SetBackColor( Turbine.UI.Color( .9, .1, .4, .9) );
	centerLabelBLabelHelp:SetZOrder(-1);

	buttonDefineHelp.MouseEnter = function()
		helpButtonLabel:SetVisible(true);
	end

	buttonDefineHelp.MouseLeave = function()
		helpButtonLabel:SetVisible(false);
	end

	buttonDefineHelp.MouseClick = function(sender, args)
		GenerateHelpWindow(2);
		HelpWindow:SetVisible(true);
	end

	posx = 10;
	posy = 20;

	local SizeOfMap = 0;
	SizeOfMap = SizeOfMap + (76 * 45) + 30;

	-- create the viewport control all it needs is size and position as it is simply used to create viewable bounds for our map
	viewport1=Turbine.UI.Control();
	viewport1:SetParent(UIShowReput);
	viewport1:SetSize(windowWidth - 45, windowHeight - 130);

	viewport1:SetPosition(10, 50);
	-- create the map content for our viewport, again, it only needs size and position as it is just a container for the grid of images
	viewport1.map=Turbine.UI.Control();
	viewport1.map:SetParent(viewport1); -- set the map as a child of the viewport so that it will be bounded by it for drawing purposes
	viewport1.map:SetSize(windowWidth - 45, SizeOfMap); -- we'll use a 5x4 grid but this obviously could be expanded, or even set up as a recycled array of controls
	viewport1.map:SetPosition(0,0); -- we'll start off in the upper left

	LabelNameFaction = {};

	for i=1, 76 do 
		if(PlayerDatas[NamePlayerToShow].align == 1)then

			------------------------------------------------------------------------------------------
			--- cut off the name if too long
			------------------------------------------------------------------------------------------
			LabelNameFaction[i]=Turbine.UI.Label(); 
			LabelNameFaction[i]:SetParent(viewport1.map); 
			LabelNameFaction[i]:SetSize(350, 30); 
			LabelNameFaction[i]:SetPosition(posx, posy); 
			LabelNameFaction[i]:SetText(Strings["reputname" .. i]); 
			LabelNameFaction[i]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			LabelNameFaction[i]:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
			LabelNameFaction[i]:SetForeColor(Turbine.UI.Color.Gold);

			if(NamePlayerToShow == PlayerName)then
				LabelNameFaction[i].MouseClick = function(sender, args)
					CreateAddNewWindowReput(Strings["reputname" .. i], NamePlayerToShow, i);
					AltHolicAddnewWindowReput:SetVisible(true);
				end
			end


			posy = posy + 15;

			local reputVal = 0;
			local nextValReput = 0;
			local percentReput = 0;
			local reputationValueMax = {-20000,
									-10000,
									0,
									10000,
									30000,
									55000,
									85000,
									130000,
									190000,
									280000,
									480000};

			if(PlayerReput[NamePlayerToShow]["Reput" .. i].position == Strings.reputposition1)then
				reputVal = reputationValueMax[1];
				nextValReput = reputationValueMax[2];
			elseif(PlayerReput[NamePlayerToShow]["Reput" .. i].position == Strings.reputposition2)then
				reputVal = reputationValueMax[2];
				nextValReput = reputationValueMax[3];
			elseif(PlayerReput[NamePlayerToShow]["Reput" .. i].position == Strings.reputposition3)then
				reputVal = reputationValueMax[3];
				nextValReput = reputationValueMax[4];
			elseif(PlayerReput[NamePlayerToShow]["Reput" .. i].position == Strings.reputposition4)then
				reputVal = reputationValueMax[4];
				nextValReput = reputationValueMax[5];
			elseif(PlayerReput[NamePlayerToShow]["Reput" .. i].position == Strings.reputposition5)then
				reputVal = reputationValueMax[5];
				nextValReput = reputationValueMax[6];
			elseif(PlayerReput[NamePlayerToShow]["Reput" .. i].position == Strings.reputposition6)then
				reputVal = reputationValueMax[6];
				nextValReput = reputationValueMax[7];
			elseif(PlayerReput[NamePlayerToShow]["Reput" .. i].position == Strings.reputposition7)then
				reputVal = reputationValueMax[7];
				nextValReput = reputationValueMax[8];
			elseif(PlayerReput[NamePlayerToShow]["Reput" .. i].position == Strings.reputposition8)then
				reputVal = reputationValueMax[8];
				nextValReput = reputationValueMax[9];
			elseif(PlayerReput[NamePlayerToShow]["Reput" .. i].position == Strings.reputposition9)then
				reputVal = reputationValueMax[9];
				nextValReput = reputationValueMax[10];
			elseif(PlayerReput[NamePlayerToShow]["Reput" .. i].position == Strings.reputposition10)then
				reputVal = reputationValueMax[10];
				nextValReput = reputationValueMax[11];
			end

			if(PlayerReput[NamePlayerToShow]["Reput" .. i].value ~= nil)then
				percentReput = ((PlayerReput[NamePlayerToShow]["Reput" .. i].value - reputVal) * 100) / nextValReput;
			end

			UIShowReput.Message=Turbine.UI.Label(); 
			UIShowReput.Message:SetParent(viewport1.map); 
			UIShowReput.Message:SetSize(350, 30); 
			UIShowReput.Message:SetPosition(posx + 10, posy + 3); 
			if(PlayerReput[NamePlayerToShow]["Reput" .. i].value ~= nil)then
				UIShowReput.Message:SetText(tostring((PlayerReput[NamePlayerToShow]["Reput" .. i].value - reputVal)) .. " / " .. tostring(comma_value(nextValReput)));
			else
				UIShowReput.Message:SetText("Enter a value to start");
			end
			UIShowReput.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			UIShowReput.Message:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18);
			UIShowReput.Message:SetForeColor(Turbine.UI.Color.White);
			UIShowReput.Message:SetZOrder(12);

			-- filled up box
			--debug
			--PlayerReput[NamePlayerToShow]["Reput" .. i].value = 50;


			local sizeOfFilling = (percentReput * 350) / 100;

			UIShowReput.Message=Turbine.UI.Label(); 
			UIShowReput.Message:SetParent(viewport1.map); 
			UIShowReput.Message:SetSize(sizeOfFilling, 15); 
			UIShowReput.Message:SetPosition(posx + 10, posy + 10); 
			UIShowReput.Message:SetText(""); 
			UIShowReput.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
			UIShowReput.Message:SetBackColor(Turbine.UI.Color.Blue);
			UIShowReput.Message:SetZOrder(11);

			UIShowReput.Message=Turbine.UI.Label(); 
			UIShowReput.Message:SetParent(viewport1.map); 
			UIShowReput.Message:SetSize(350, 15); 
			UIShowReput.Message:SetPosition(posx + 10, posy + 10); 
			UIShowReput.Message:SetText(""); 
			UIShowReput.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
			UIShowReput.Message:SetBackColor(Turbine.UI.Color.Black);
			UIShowReput.Message:SetZOrder(10);

			UIShowReput.Message=Turbine.UI.Label(); 
			UIShowReput.Message:SetParent(viewport1.map); 
			UIShowReput.Message:SetSize(352, 17); 
			UIShowReput.Message:SetPosition(posx + 9, posy + 9); 
			UIShowReput.Message:SetText(""); 
			UIShowReput.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
			UIShowReput.Message:SetBackColor(Turbine.UI.Color( 1, 0.5, 0.5, 0.5 ));



			-- position alignement with faction

			UIShowReput.Message=Turbine.UI.Label(); 
			UIShowReput.Message:SetParent(viewport1.map); 
			UIShowReput.Message:SetSize(120, 30); 
			UIShowReput.Message:SetPosition(posx + 10, posy + 16); 
			UIShowReput.Message:SetText( PlayerReput[NamePlayerToShow]["Reput" .. i].position ); 
			UIShowReput.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
			UIShowReput.Message:SetFont(Turbine.UI.Lotro.Font.Verdana16);
			UIShowReput.Message:SetForeColor(Turbine.UI.Color.White);
		end

		posy = posy + 30;
	end

	if(SizeOfMap >= viewport1:GetHeight())then
		-- create the vertical scrollbar for our viewport
		vscroll1=Turbine.UI.Lotro.ScrollBar();
		vscroll1:SetParent(UIShowReput);
		vscroll1:SetOrientation(Turbine.UI.Orientation.Vertical);
		vscroll1:SetPosition(windowWidth - 20, 50);
		vscroll1:SetSize(12,viewport1:GetHeight()); -- set width to 12 since it's a "Lotro" style scrollbar and the height is set to match the control that we will be scrolling
		vscroll1:SetBackColor(Turbine.UI.Color(.1,.1,.2)); -- just to give it a little style
		vscroll1:SetMinimum(0);
		vscroll1:SetMaximum(viewport1.map:GetHeight()-viewport1:GetHeight()); -- we will allow scrolling the height of the map-the viewport height
		vscroll1:SetValue(0); -- set the initial value
		-- set the ValueChanged event handler to take an action when our value changes, in this case, change the map position relative to the viewport
		vscroll1.ValueChanged=function()
			viewport1.map:SetTop(0-vscroll1:GetValue());
		end
	end


	ReputWindowButton = Turbine.UI.Lotro.GoldButton();
	ReputWindowButton:SetParent( UIShowReput );
	ReputWindowButton:SetPosition(windowWidth/2 - 125, windowHeight - 50);
	ReputWindowButton:SetSize( 300, 20 );
	ReputWindowButton:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	ReputWindowButton:SetText( Strings.PluginCloseButton );
	ReputWindowButton:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	ReputWindowButton:SetVisible(true);
	ReputWindowButton:SetMouseVisible(true);

	ReputWindowButton.MouseClick = function(sender, args)
		settings["isReputWindowVisible"]["isReputWindowVisible"] = false;
		UIShowReput:SetVisible(false);
	end


	ClosingTheWindowReput();

	UIShowReput.KeyDown=function(sender, args)
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			UIShowReput:SetVisible(false);
			settings["isReputWindowVisible"]["isReputWindowVisible"] = false;
		end
	
		-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
		if ( args.Action == 268435635 ) then
			hudVisible=not hudVisible;
			if hudVisible then
				UIShowReput:SetVisible(false);
				MainMinimizedIcon:SetVisible(false);
			else
				UIShowReput:SetVisible(settings.isReputWindowVisible);
				MainMinimizedIcon:SetVisible(true);
			end
		end
	end

end